const CACHE_NAME = 'app-cache-v24'
const CACHE_RESOURCE = [
  '/',
  '/favicon.ico',
]

// install
self.addEventListener('install', (e) => {
  console.log('EVENT => install')
  async function preCacheResources()
  {
    const cache = await caches.open(CACHE_NAME)
    return cache.addAll(CACHE_RESOURCE)
  }
  e.waitUntil(preCacheResources())
  // TODO: 강제로 activate 이벤트를 트리깅한다.
  self.skipWaiting().then()
})

// activate
self.addEventListener('activate', event => {
  console.log('EVENT => activate')
  async function clearOldCache()
  {
    const keys = await caches.keys()
    await Promise.all(keys.map(name => {
      if (name !== CACHE_NAME) return caches.delete(name)
    }))
  }
  event.waitUntil(clearOldCache())
})

// fetch
self.addEventListener('fetch', e => {
  // console.log('EVENT => fetch')
  async function returnCachedResource()
  {
    const cache = await caches.open(CACHE_NAME)
    const cachedResponse = await cache.match(e.request.url)
    if (cachedResponse)
    {
      return cachedResponse
    }
    else
    {
      const fetchResponse = await fetch(e.request.url)
      // TODO: `cache.put` 메서드는 전송하는 파일을 캐시에다 추가한다.
      // await cache.put(e.request.url, fetchResponse.clone())
      return fetchResponse
    }
  }
  e.respondWith(returnCachedResource())
})
